



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Luogu  P2048 [NOI2010]超级钢琴</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Luogu  P2048 [NOI2010]超级钢琴</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-16 12:17:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这道题<strong>题号</strong>很清新啊！第一次开NOI的题，因为最近考到了这道题的<strong>升级版</strong>。</p>
<p>我们先考虑\(O(n^2)\)大暴力，就是枚举前后端点然后开一个前缀和减一下即可。</p>
<p>然后引入正解，我们设一个三元组\(F(s,l,r)\)表示以\(s\)为左端点，右端点的范围在\([l,r]\)的时候最优的右端点为多少。</p>
<p>左端点确定了，右端点的区间也确定了，那么右端点的位置怎么求？</p>
<p><strong>RMQ</strong>直接查询即可。由于要求值最大，因此我们RMQ出<strong>前缀和</strong>最大值即可</p>
<p>然后我们就可以得到一些三元组，考虑如何计算答案。</p>
<p>我们还是通过<strong>取最大值</strong>这点性质想到<strong>堆</strong>。因此我们用<strong>大根堆</strong>来维护，而要维护的东西应该就是这个区间的值了。</p>
<p>然后前缀和的作用就出来了。我们在比较时让键值为\(sum_t-sum_{s-1}\)即可。</p>
<p>当我们取出一个解时，注意以\(s\)为左端点的区间就不是没有用了，我们可以把它按选择的最优位置分裂成两半然后<strong>再扔回堆</strong>里为后续的做准备。</p>
<p>具体实现看CODE</p>
<pre class="prettyprint linenums"><code>#include&lt;cstdio&gt;<br />
#include&lt;cctype&gt;<br />
#include&lt;queue&gt;<br />
using namespace std;<br />
const int N=500005,P=25;<br />
int n,k,l,r,sum[N],log[N];<br />
long long ans;<br />
struct data<br />
{<br />
    int s,l,r,t;<br />
    bool operator &lt;(const data x) const { return sum[x.t]-sum[x.s-1]&gt;sum[t]-sum[s-1]; }<br />
};<br />
struct RMQ<br />
{<br />
    int x,num;<br />
}f[N][P];<br />
priority_queue&lt;data&gt; big;<br />
inline char tc(void)<br />
{<br />
    static char fl[100000],*A=fl,*B=fl;<br />
    return A==B&amp;&amp;(B=(A=fl)+fread(fl,1,100000,stdin),A==B)?EOF:*A++;<br />
}<br />
inline void read(int &amp;x)<br />
{<br />
    x=0; char ch; int flag=1; while (!isdigit(ch=tc())) flag=ch^'-'?1:-1;<br />
    while (x=(x&lt;&lt;3)+(x&lt;&lt;1)+ch-'0',isdigit(ch=tc())); x*=flag;<br />
}<br />
inline int min(int a,int b)<br />
{<br />
    return a&lt;b?a:b;<br />
}<br />
inline void log_init(void)<br />
{<br />
    for (register int i=2;i&lt;=n;++i)<br />
    log[i]=log[i&gt;&gt;1]+1;<br />
}<br />
inline void RMQ_init(void)<br />
{<br />
    for (register int j=1;j&lt;P;++j)<br />
    for (register int i=1;i+(1&lt;&lt;j)-1&lt;=n;++i)<br />
    f[i][j]=f[i][j-1].x&gt;f[i+(1&lt;&lt;j-1)][j-1].x?f[i][j-1]:f[i+(1&lt;&lt;j-1)][j-1];<br />
}<br />
inline int query(int l,int r)<br />
{<br />
    int k=log[r-l+1];<br />
    return f[l][k].x&gt;f[r-(1&lt;&lt;k)+1][k].x?f[l][k].num:f[r-(1&lt;&lt;k)+1][k].num;<br />
}<br />
int main()<br />
{<br />
    //freopen(&quot;CODE.in&quot;,&quot;r&quot;,stdin); freopen(&quot;CODE.out&quot;,&quot;w&quot;,stdout);<br />
    register int i; read(n); read(k); read(l); read(r);<br />
    for (i=1;i&lt;=n;++i)<br />
    read(sum[i]),sum[i]+=sum[i-1],f[i][0]=((RMQ){sum[i],i});<br />
    log_init(); RMQ_init();<br />
    for (i=1;i&lt;=n;++i)<br />
    if (i+l-1&lt;=n) big.push((data){i,i+l-1,min(n,i+r-1),query(i+l-1,min(n,i+r-1))});<br />
    while (k--)<br />
    {<br />
        data now=big.top(); big.pop(); ans+=sum[now.t]-sum[now.s-1];<br />
        if (now.l^now.t) big.push((data){now.s,now.l,now.t-1,query(now.l,now.t-1)});<br />
        if (now.r^now.t) big.push((data){now.s,now.t+1,now.r,query(now.t+1,now.r)});<br />
    }<br />
    return printf(&quot;%lld&quot;,ans),0;<br />
}<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwj5rr8.html">SemanticZoom配合GridView组件的使用关键点</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qngv1j8.html">JAVA求解线性方程组-列主元高斯消去法</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rpgzd8.html">NYOJ之括号配对问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jo1keq.html">ORACLE 常用函数 日期&sol;时间函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wzlmxq.html">本机运行&period;net 2&period;0项目报错，解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1wm519.html">CSS中display&colon;block的使用介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vod5n8.html">SWFUpload的使用及其注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmzkj09.html">jsf小例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyexwm9.html">VMware Workstation9安装Mac OS X10&period;9系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gem3778.html">Windows下用Mingw编译Boost&period;Regex库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpw7kzq.html">json-smart 使用示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kporp79.html">各种编码之间的关系以及getBytes的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/950p1lv8.html">HDU1114--Piggy-Bank&lpar;完全背包变形&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1p27xq.html">zabbix自定义key监控memcache状态及其他服务进程</a>
		</li>
						<li><a href="https://www.batexi.com/a/960jxny9.html">shiro三连斩之第三斩，整合 springboot</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll1o5eq.html">Android内存优化（五） Lint代码扫描工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wneg0q.html">MVC（面试）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwvl248.html">Jquery&plus;asp&period;net实现Ajax方式文件下载实例代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zklo1x8.html">Visual Categorization with Bags of Keypoints</a>
		</li>
						<li><a href="https://www.batexi.com/a/963ke639.html">centos升级glibc动态库</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kjdd339.html">Linux&amp;&num;160&semi;学习笔记之超详细基础linux命令&amp;&num;160&semi;Part&amp;&num;160&semi;14</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvl0n38.html">PullToRefreshGridView上拉刷新，下拉加载</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oj3v18.html">Android深入四大组件（八）广播的注册、发送和接收过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r15jj9.html">在ASP&period;NET Core中使用多环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5wly7q.html">多浏览器播放wav格式的音频文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zylno19.html">windows10不能获取有效IP的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rd6528.html">php中编码转换方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9604w639.html">flask框架的教程--虚拟环境的安装&lbrack;一&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oj5ne8.html">02LaTeX学习系列之---TeX环境的搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd4vv09.html">for&lpar;var i&equals;1&semi;i&amp;lt&semi;&equals;3&semi;i&plus;&plus;&rpar;&lbrace; setTimeout&lpar;function&lpar;&rpar;&lbrace; console&period;log&lpar;i&rpar;&semi; &rcub;&comma;0&rpar;&semi; &rcub;&semi;答案：4 4 4。</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
